﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Drawing.Drawing2D;


namespace WindowsFormsApplication1
{
    class image_rectangule_drawing
    {
        public Image DrawRectangleInPicture(Image image1, Point p0, Point p1, Color RectColor, int LineWidth)//, DashStyle ds)
        {
            try
            {
                //return image1; 
                if (image1 == null) return null;
                Bitmap bm = new Bitmap(image1, image1.Width, image1.Height);
                using (Graphics g = Graphics.FromImage(bm))
                {
                    Brush brush = new SolidBrush(RectColor);
                    Pen pen = new Pen(brush, LineWidth);
                    pen.DashStyle = DashStyle.Solid;
                    g.DrawRectangle(pen, new Rectangle(p0.X, p0.Y, Math.Abs(p0.X - p1.X), Math.Abs(p0.Y - p1.Y)));
                    g.Dispose();
                }

                return bm;
            }
            catch (Exception)
            {
                return null;
            }
        }
                                                                   


    }
}
